#include <AFMotor.h>
#include <NewPing.h>
#include <Servo.h>

NewPing radar(A0, A1, 200);
Servo srv;

AF_DCMotor motor1(1, MOTOR12_1KHZ);
AF_DCMotor motor2(2, MOTOR12_1KHZ);
AF_DCMotor motor3(3, MOTOR34_1KHZ);
AF_DCMotor motor4(4, MOTOR34_1KHZ);


boolean inainte;
int dist;
int distDr;
int distSt;

void setup() {
  dist = 100;
  inainte = 0;
  delay(100);
  srv.attach(10);
  srv.write(115);
  delay(2000);
  dist = calcPing();
  delay(100);
}

void loop() {
  
  distDr = 0;
  distSt =  0;
  delay(50);

  if (dist < 20) {
    stopCar();
    delay(100);
    mvBk();
    delay(300);
    stopCar();
    delay(300);
    distDr = verifDr();
    delay(200);
    distSt = verifSt();
    delay(200);

    if (distSt > distDr) {
      setSt();
      stopCar();
    } else {
      setDr();
      stopCar();
    }
  } else {
    moveForward();
  }
  dist = calcPing();
}

int verifDr()
{
  srv.write(170);
  delay(500);
  int dist2 = calcPing();
  delay(100);
  srv.write(115);
  return dist2;
}

int verifSt()
{
  srv.write(50);
  delay(500);
  int dist2 = calcPing();
  delay(100);
  srv.write(115);
  return dist2;
}



int calcPing() {
  delay(70);
  int d = radar.ping_cm();
  if (d == 0)
  {
    return 300;
  }
  return d;
}

void moveForward() {

  if (inainte == 0) {
    inainte = 1;
    set_motors_fw();
    motor1.setSpeed(200);
    motor2.setSpeed(200);
    motor3.setSpeed(200);
    motor4.setSpeed(200);
    delay(10);
  }
}

void mvBk() {
  inainte = 0;
  set_motors_bk();
  motor1.setSpeed(200);
  motor2.setSpeed(200);
  motor3.setSpeed(200);
  motor4.setSpeed(200);
  delay(10);
}

void set_motors_fw() {
  motor1.run(FORWARD);
  motor2.run(FORWARD);
  motor3.run(FORWARD);
  motor4.run(FORWARD);
}

void set_motors_bk() {
  motor1.run(BACKWARD);
  motor2.run(BACKWARD);
  motor3.run(BACKWARD);
  motor4.run(BACKWARD);
}

void setDr() {
  motor1.run(FORWARD);
  motor2.run(FORWARD);
  motor3.run(BACKWARD);
  motor4.run(BACKWARD);
  delay(500);
  set_motors_fw();
}

void setSt() {
  motor1.run(BACKWARD);
  motor2.run(BACKWARD);
  motor3.run(FORWARD);
  motor4.run(FORWARD);
  delay(500);
  set_motors_fw();
}

void stopCar() {
  motor1.run(RELEASE);
  motor2.run(RELEASE);
  motor3.run(RELEASE);
  motor4.run(RELEASE);
}
